diff --git a/src/isdn/Q921.c b/src/isdn/Q921.c
index 2dad5cf..a682c23 100644
--- a/src/isdn/Q921.c
+++ b/src/isdn/Q921.c
@@ -105,82 +830,468 @@ int Q921Tx23Proc(L2TRUNK trunk, L2UCHAR *Msg, L2INT size)
   Return Value: none
 
 *****************************************************************************/
-L2ULONG (*Q921GetTimeProc) (void) = NULL; /* callback for func reading time in ms */
-L2ULONG tLast = {0};
+static L2ULONG (*Q921GetTimeProc) (void) = NULL; /* callback for func reading time in ms */
+static L2ULONG tLast = {0};
 
-L2ULONG Q921GetTime(void)
+static L2ULONG Q921GetTime(void)
 {
-    L2ULONG tNow = 0;
-    if(Q921GetTimeProc != NULL)
-    {
-        tNow = Q921GetTimeProc();
-        if(tNow < tLast)    /* wrapped */
-        {
+	L2ULONG tNow = 0;
+
+	if(Q921GetTimeProc)
+	{
+		tNow = Q921GetTimeProc();
+		if(tNow < tLast)	/* wrapped */
+		{
 			/* TODO */
-        }
+		}
 		tLast = tNow;
-    }
-    return tNow;
+	}
+	return tNow;
 }
 
-void Q921T200TimerStart(L2TRUNK trunk)
+/*
+ * T200 handling (per-TEI in PTMP NT mode, tei=0 otherwise)
+ */
+static void Q921T200TimerStart(L2TRUNK trunk, L2UCHAR tei)
 {
-	if (!trunk->T200) {
-		trunk->T200 = Q921GetTime() + trunk->T200Timeout;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	if (!link->T200) {
+		link->T200 = Q921GetTime() + trunk->T200Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T200 (timeout: %d msecs) started for TEI %d\n", trunk->T200Timeout, tei);
 	}
 }
 
-void Q921T200TimerStop(L2TRUNK trunk)
+static void Q921T200TimerStop(L2TRUNK trunk, L2UCHAR tei)
 {
-	trunk->T200 = 0;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->T200 = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T200 stopped for TEI %d\n", tei);
 }
 
-void Q921T200TimerReset(L2TRUNK trunk)
+static void Q921T200TimerReset(L2TRUNK trunk, L2UCHAR tei)
 {
-	Q921T200TimerStop(trunk);
-	Q921T200TimerStart(trunk);
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->T200 = Q921GetTime() + trunk->T200Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T200 (timeout: %d msecs) restarted for TEI %d\n", trunk->T200Timeout, tei);
 }
 
-void Q921T203TimerStart(L2TRUNK trunk)
+/*
+ * T203 handling (per-TEI in PTMP NT mode, tei=0 otherwise)
+ */
+static void Q921T203TimerStart(L2TRUNK trunk, L2UCHAR tei)
 {
-	if (!trunk->T203) {
-		trunk->T203 = Q921GetTime() + trunk->T203Timeout;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	if (!link->T203) {
+		link->T203 = Q921GetTime() + trunk->T203Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T203 (timeout: %d msecs) started for TEI %d\n", trunk->T203Timeout, tei);
 	}
 }
 
-void Q921T203TimerStop(L2TRUNK trunk)
+static void Q921T203TimerStop(L2TRUNK trunk, L2UCHAR tei)
 {
-	trunk->T203 = 0;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->T203 = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T203 stopped for TEI %d\n", tei);
 }
 
-void Q921T203TimerReset(L2TRUNK trunk)
+static void Q921T203TimerReset(L2TRUNK trunk, L2UCHAR tei)
 {
-	Q921T203TimerStop(trunk);
-	Q921T203TimerStart(trunk);
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->T203 = Q921GetTime() + trunk->T203Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T203 (timeout: %d msecs) restarted for TEI %d\n", trunk->T203Timeout, tei);
 }
 
-void Q921T200TimerExpire(L2TRUNK trunk)
+/*
+ * T202 handling (TEI message timeout, TE mode only)
+ */
+static void Q921T202TimerStart(L2TRUNK trunk)
 {
-	(void)trunk;
+	if (!trunk->T202) {
+		trunk->T202 = Q921GetTime() + trunk->T202Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T202 (timeout: %d msecs) started\n", trunk->T202Timeout);
+	}
 }
 
-void Q921T203TimerExpire(L2TRUNK trunk)
+static void Q921T202TimerStop(L2TRUNK trunk)
 {
-	Q921T203TimerReset(trunk);
-	Q921SendRR(trunk, trunk->sapi, trunk->NetUser == Q921_TE ? 0 : 1, trunk->tei, 1);
+	trunk->T202 = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T202 stopped\n");
 }
 
-void Q921TimerTick(L2TRUNK trunk)
+static void Q921T202TimerReset(L2TRUNK trunk)
 {
-	L2ULONG tNow = Q921GetTime();
-	if (trunk->T200 && tNow > trunk->T200) {
-		Q921T200TimerExpire(trunk);
+	trunk->T202 = Q921GetTime() + trunk->T202Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T202 (timeout: %d msecs) restarted\n", trunk->T202Timeout);
+}
+
+/*
+ * T201 handling (TEI management (NT side), per-TEI)
+ */
+static void Q921T201TimerStart(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	if (!link->T201) {
+		link->T201 = Q921GetTime() + trunk->T201Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "T201 (timeout: %d msecs) started for TEI %d\n", trunk->T201Timeout, tei);
+	}	
+}
+
+static void Q921T201TimerStop(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->T201 = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T201 stopped for TEI %d\n", tei);
+}
+
+#ifdef __UNUSED_FOR_NOW__
+static void Q921T201TimerReset(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->T201 = Q921GetTime() + trunk->T201Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T201 (timeout: %d msecs) restarted for TEI %d\n", trunk->T201Timeout, tei);
+}
+#endif
+
+/*
+ * TM01 handling (Datalink inactivity shutdown timer)
+ */
+static void Q921TM01TimerStart(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	if (!link->TM01) {
+		link->TM01 = Q921GetTime() + trunk->TM01Timeout;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "TM01 (timeout: %d msecs) started for TEI %d\n", trunk->TM01Timeout, tei);
+	}
+}
+
+#ifdef __UNUSED_FOR_NOW__
+static void Q921TM01TimerStop(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->TM01 = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "TM01 stopped for TEI %d\n", tei);
+}
+#endif
+
+static void Q921TM01TimerReset(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	link->TM01 = Q921GetTime() + trunk->TM01Timeout;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "TM01 (timeout: %d msecs) restarted for TEI %d\n", trunk->TM01Timeout, tei);
+}
+
+/*
+ * Expiry callbacks
+ */
+static void Q921T200TimerExpire(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link   = Q921_LINK_CONTEXT(trunk, tei);
+	struct Q921_Link *trlink = Q921_TRUNK_CONTEXT(trunk);
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T200 expired for TEI %d (trunk TEI %d)\n", tei, trlink->tei);
+
+	/* Stop timer first */
+	Q921T200TimerStop(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+		if(link->N200 >= trunk->N200Limit) {
+			/* Discard I queue */
+			MFIFOClear(link->IFrameQueue);
+
+			/* MDL-Error indication (G) */
+			Q921Log(trunk, Q921_LOG_ERROR, "Failed to establish Q.921 link in %d retries\n", link->N200);
+
+			/* DL-Release indication */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE, tei, NULL, 0);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED, tei);
+		} else {
+			/* Increment retry counter */
+			link->N200++;
+
+			/* Send SABME */
+			Q921SendSABME(trunk,
+					trunk->sapi,
+					Q921_COMMAND(trunk),
+					tei,
+					1);
+
+			/* Start T200 */
+			Q921T200TimerStart(trunk, tei);
+		}
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		link->N200 = 0;
+
+		if(!Q921_CHECK_FLAG(link, Q921_FLAG_PEER_RECV_BUSY)) {
+			/* get last transmitted I frame */
+
+			/* V(S) = V(S) - 1 */
+			Q921_DEC_COUNTER(link->vs);
+
+			/* retransmit I frame */
+
+			/* V(S) = V(S) + 1 (done by Q921SendI() ) */
+			//Q921_INC_COUNTER(link->vs);
+
+			/* clear acknowledge pending */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+
+			/* Start T200 */
+			Q921T200TimerStart(trunk, tei);
+		} else {
+			/* transmit enquiry */
+			Q921SendEnquiry(trunk, tei);
+		}
+
+		/* increment counter */
+		link->N200++;
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_TIMER_RECOVERY, tei);
+		break;
+
+	case Q921_STATE_TIMER_RECOVERY:
+		if(link->N200 == trunk->N200Limit) {
+			/* MDL Error indication (I) */
+
+			/* Establish data link */
+			Q921EstablishDataLink(trunk, tei);
+
+			/* Clear L3 initiated */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, tei);
+		} else {
+			if(link->vs == link->va) {
+				/* transmit enquiry */
+				Q921SendEnquiry(trunk, tei);
+
+			} else if(!Q921_CHECK_FLAG(link, Q921_FLAG_PEER_RECV_BUSY)) {
+				/* get last transmitted frame */
+
+				/* V(S) = V(S) - 1 */
+				Q921_DEC_COUNTER(link->vs);
+
+				/* retrans frame */
+
+				/* V(S) = V(S) + 1 (done by Q921SendI() ) */
+				//Q921_INC_COUNTER(link->vs);
+
+				/* clear acknowledge pending */
+				Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+
+				/* Start T200 */
+				Q921T200TimerStart(trunk, tei);
+			}
+
+			/* increment counter */
+			link->N200++;
+
+			/* no state change */
+		}
+		break;
+
+	default:
+		break;
+	}
+}
+
+static void Q921T203TimerExpire(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link   = Q921_LINK_CONTEXT(trunk, tei);
+	struct Q921_Link *trlink = Q921_TRUNK_CONTEXT(trunk);
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T203 expired for TEI %d (trunk TEI %d)\n", tei, trlink->tei);
+
+	/* Stop Timer first */
+	Q921T203TimerStop(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* Send Enquiry */
+		Q921SendEnquiry(trunk, tei);
+
+		/* RC = 0 */
+		link->N200 = 0;
+
+		/* no state change */
+		break;
+
+	default:
+		break;
+	}
+}
+
+static void Q921T202TimerExpire(L2TRUNK trunk)
+{
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+
+	Q921T202TimerReset(trunk);
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T202 expired for Q.921 trunk with TEI %d\n", link->tei);
+
+	/* todo: implement resend counter */
+
+	switch(link->state) {
+	case Q921_STATE_TEI_ASSIGNED:	/* Tei identity verify timeout */
+		Q921TeiSendVerifyRequest(trunk);
+		break;
+
+	default:			/* Tei assignment request timeout (TODO: refine) */
+
+		if(trunk->N202 >= trunk->N202Limit) {
+			/* Too many retransmits, reset counter, stop timer and handle case (TODO) */
+			trunk->N202 = 0;
+
+			Q921T202TimerStop(trunk);
+
+			return;
+		}
+		Q921TeiSendAssignRequest(trunk);
+
+		trunk->N202++;
 	}
-	if (trunk->T203 && tNow > trunk->T203) {
-		Q921T203TimerExpire(trunk);		
+}
+
+static void Q921T201TimerExpire(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link   = Q921_LINK_CONTEXT(trunk, tei);
+	struct Q921_Link *trlink = Q921_TRUNK_CONTEXT(trunk);
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "T201 expired for TEI %d (trunk TEI: %d)\n", tei, trlink->tei);
+
+	Q921T201TimerStop(trunk, tei);
+
+	/* NOTE: abusing N202 for this */
+	if(link->N202 < trunk->N202Limit) {
+		/* send check request */
+		Q921TeiSendCheckRequest(trunk, tei);
+
+		/* increment counter */
+		link->N202++;
+	} else {
+		/* put context in STOPPED state */
+		Q921ChangeState(trunk, Q921_STATE_STOPPED, tei);
+
+		/* NOTE: should we clear the link too? */
+		memset(link, 0, sizeof(struct Q921_Link));
+
+		/* mark TEI free */
+		trunk->tei_map[tei] = 0;
 	}
 }
 
+#ifdef __UNUSED_FOR_NOW__
+static void Q921TM01TimerExpire(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link   = Q921_LINK_CONTEXT(trunk, tei);
+	struct Q921_Link *trlink = Q921_TRUNK_CONTEXT(trunk);
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "TM01 expired for TEI %d (trunk TEI: %d)\n", tei, trlink->tei);
+
+	/* Restart TM01 */
+	Q921TM01TimerReset(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+/*
+ * NT-only, needs more support from L3
+ */
+#if 0
+		/* No activity, shutdown link */
+		Q921SendDISC(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+
+		/* clear I queue */
+		MFIFOClear(link->IFrameQueue);
+
+		/* change state */
+		Q921ChangeState(trunk, Q921_STATE_AWAITING_RELEASE, tei);
+#endif
+		break;
+
+	default:
+		break;
+	}
+}
+#endif
+
+/*
+ * Timer Tick function
+ */
+void Q921TimerTick(L2TRUNK trunk)
+{
+	struct Q921_Link *link;
+	L2ULONG tNow = Q921GetTime();
+	int numlinks = Q921_IS_PTMP_NT(trunk) ? Q921_TEI_MAX : 1;
+	int x;
+
+	for(x = 0; x <= numlinks; x++) {
+		link = Q921_LINK_CONTEXT(trunk, x);
+
+		/* TODO: check if TEI is assigned and skip check if not (speedup!) */
+		if(link->state == Q921_STATE_STOPPED)
+			continue;
+
+		if (link->T200 && tNow > link->T200) {
+			Q921T200TimerExpire(trunk, link->tei);
+		}
+		if (link->T203 && tNow > link->T203) {
+			Q921T203TimerExpire(trunk, link->tei);		
+		}
+
+		if(Q921_IS_PTMP_NT(trunk) && link->tei) {
+			if (link->T201 && tNow > link->T201) {
+				Q921T201TimerExpire(trunk, link->tei);
+			}
+		}
+
+		if(!Q921_IS_PTMP_NT(trunk)) {
+			if (trunk->T202 && tNow > trunk->T202) {
+				Q921T202TimerExpire(trunk);
+			}
+		}
+
+		/* Send enqueued I frame, if available */
+		Q921SendQueuedIFrame(trunk, link->tei);
+
+		/* Send ack if pending */
+		Q921AcknowledgePending(trunk, link->tei);
+	}
+
+}
 
 void Q921SetGetTimeCB(L2ULONG (*callback)(void))
 {
@@ -211,45 +1322,292 @@ int Q921QueueHDLCFrame(L2TRUNK trunk, L2UCHAR *b, L2INT size)
     return MFIFOWriteMes(trunk->HDLCInQueue, b, size);
 }
 
-/*****************************************************************************
+/**
+ * Q921EnqueueI
+ * \brief	Put I frame into transmit queue
+ *
+ */
+static int Q921EnqueueI(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR *mes, L2INT size)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, Tei);
 
-  Function:     Q921SendI
+	/* I frame header */
+	mes[trunk->Q921HeaderSpace+0] = ((Sapi << 2) & 0xfc) | ((cr << 1) & 0x02);
+	mes[trunk->Q921HeaderSpace+1] = (Tei << 1) | 0x01;
+	mes[trunk->Q921HeaderSpace+2] = 0x00;
+	mes[trunk->Q921HeaderSpace+3] = (pf & 0x01);
 
-  Description:  Compose and Send I Frame to layer. Will receive an I frame
-                with space for L2 header and fill out that header before
-                it call Q921Tx21Proc.
+	Q921Log(trunk, Q921_LOG_DEBUG, "Enqueueing I frame for TEI %d [%d]\n", link->tei, Tei);
 
-  Parameters:   trunk       trunk #
-                Sapi        Sapi
-                cr          C/R field.
-                Tei         Tei.
-                pf          P fiels octet 5
-                mes         ptr to I frame message.
-                size        size of message in bytes.
+	/* transmit queue, (TODO: check for full condition!) */
+	MFIFOWriteMes(link->IFrameQueue, mes, size);
 
-  Return Value: 0 if failed, 1 if Send.
+	/* try to send queued frame */
+	Q921SendQueuedIFrame(trunk, link->tei);
 
-*****************************************************************************/
-int Q921SendI(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR *mes, L2INT size)
+	return 1;
+}
+
+/**
+ * Q921SendQueuedIFrame
+ * \brief	Try to transmit queued I frame (if available)
+ */
+static int Q921SendQueuedIFrame(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	L2INT size = 0;
+	L2UCHAR *mes;
+
+	if(MFIFOGetMesCount(link->IFrameQueue) == 0) {
+		return 0;
+	}
+
+	/* Link ready? */
+	if(link->state != Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+		return 0;
+	}
+
+	/* peer receiver busy? */
+	if(Q921_CHECK_FLAG(link, Q921_FLAG_PEER_RECV_BUSY)) {
+		return 0;
+	}
+
+	/* V(S) = V(A) + k? */
+	if(link->vs == ((link->va + trunk->k) % 128)) {
+		Q921Log(trunk, Q921_LOG_WARNING, "Maximum number (%d) of outstanding I frames reached for TEI %d\n", trunk->k, tei);
+		return 0;
+	}
+
+	mes = MFIFOGetMesPtr(link->IFrameQueue, &size);
+	if(mes) {
+		/* Fill in + update counter values */
+		mes[trunk->Q921HeaderSpace+2]  = link->vs << 1;
+		mes[trunk->Q921HeaderSpace+3] |= link->vr << 1;
+
+		if(MFIFOGetMesCount(link->IFrameQueue) == 0) {
+			/* clear I frame queued */
+		}
+
+		/* Send I frame */
+		Q921Tx21Proc(trunk, mes, size);
+
+		/* V(S) = V(S) + 1 */
+		Q921_INC_COUNTER(link->vs);
+
+		/* clear acknowledge pending */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+
+		/* T200 running? */
+		if(!link->T200) {
+			/* Stop T203, Start T200 */
+			Q921T200TimerStart(trunk, tei);
+			Q921T203TimerStop(trunk, tei);
+		}
+
+		/* put frame into resend queue */
+		MFIFOWriteMesOverwrite(link->IFrameResendQueue, mes, size);
+
+		/* dequeue frame */
+		MFIFOKillNext(link->IFrameQueue);
+
+		/* Restart TM01 */
+		if(Q921_IS_NT(trunk)) {
+			Q921TM01TimerReset(trunk, tei);
+		}
+
+		/* no state change */
+		return 1;
+	}
+
+	return 0;
+}
+
+/**
+ * Q921SendS
+ * \brief	Prepare and send S frame
+ */
+static int Q921SendS(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR sv, L2UCHAR *mes, L2INT size)
 {
-    mes[trunk->Q921HeaderSpace+0] = (Sapi&0xfc) | ((cr<<1)&0x02);
-    mes[trunk->Q921HeaderSpace+1] = (Tei<<1) | 0x01;
-    mes[trunk->Q921HeaderSpace+2] = trunk->vs<<1;
-    mes[trunk->Q921HeaderSpace+3] = (trunk->vr<<1) | (pf & 0x01);
-    trunk->vs++;
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, Tei);
 
-    return Q921Tx21Proc(trunk, mes, size);
+	if(!Q921_IS_READY(link)) {
+		/* don't even bother trying */
+		Q921Log(trunk, Q921_LOG_DEBUG, "Link not ready, discarding S frame for TEI %d\n", Tei);
+		return 0;
+	}
+
+	/* S frame header */
+	mes[trunk->Q921HeaderSpace+0] = ((Sapi << 2) & 0xfc) | ((cr << 1) & 0x02);
+	mes[trunk->Q921HeaderSpace+1] = (Tei << 1) | 0x01;
+	mes[trunk->Q921HeaderSpace+2] = ((sv << 2) & 0x0c) | 0x01;
+	mes[trunk->Q921HeaderSpace+3] = (link->vr << 1) | (pf & 0x01);
+
+	return Q921Tx21Proc(trunk, mes, size);
 }
 
-int Q921Rx32(L2TRUNK trunk, L2UCHAR * Mes, L2INT Size)
+
+/**
+ * Q921SendU
+ * \brief	Prepare and send U frame
+ */
+static int Q921SendU(L2TRUNK trunk, L2UCHAR Sapi, char cr, L2UCHAR Tei, char pf, L2UCHAR m, L2UCHAR *mes, L2INT size)
 {
-	return Q921SendI(trunk, 
-					trunk->sapi, 
-					trunk->NetUser == Q921_TE ? 0 : 1,
-					trunk->tei, 
-					0, 
-					Mes, 
-					Size);
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, Tei);
+
+	/* U frame header */
+	mes[trunk->Q921HeaderSpace+0] = ((Sapi << 2) & 0xfc) | ((cr << 1) & 0x02);
+	mes[trunk->Q921HeaderSpace+1] = (Tei << 1) | 0x01;
+	mes[trunk->Q921HeaderSpace+2] = ((m << 3) & 0xe0) | ((pf << 4) & 0x10) | ((m << 2) & 0x0c) | 0x03;
+
+	/* link not ready? enqueue non-TEI-mgmt UI (DL-UNIT DATA) frames */
+	if(m == 0x00 && Sapi != Q921_SAPI_TEI && link->state < Q921_STATE_TEI_ASSIGNED) {
+
+		/* write frame to queue */
+		MFIFOWriteMes(link->UIFrameQueue, mes, size);
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Link not ready, UI Frame of size %d bytes queued for TEI %d\n", size, Tei);
+		return 1;
+	}
+
+	return Q921Tx21Proc(trunk, mes, size);
+}
+
+/**
+ * TODO: NT mode handling? Need a way to get Link context from Q.931
+ */
+int Q921Rx32(L2TRUNK trunk, Q921DLMsg_t ind, L2UCHAR tei, L2UCHAR * Mes, L2INT Size)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);	/* TODO: need real link tei for NT mode */
+	L2INT res = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Got frame from Q.931, type: %d, tei: %d, size: %d\n", ind, tei, Size);
+
+	switch(ind) {
+	case Q921_DL_ESTABLISH:
+		/*
+		 * Hmm...
+		 */
+		switch(link->state) {
+		case Q921_STATE_TEI_ASSIGNED:
+			if(!Q921_IS_NT(trunk)) {
+				/* establish data link */
+				Q921EstablishDataLink(trunk, link->tei);
+
+				/* Set layer 3 initiated */
+				Q921_SET_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, link->tei);
+			}
+			break;
+
+		case Q921_STATE_AWAITING_ESTABLISHMENT:
+			if(!Q921_IS_NT(trunk)) {
+				/* Discard I queue */
+				MFIFOClear(link->IFrameQueue);
+
+				/* Set layer 3 initiated */
+				Q921_SET_FLAG(link, Q921_FLAG_L3_INITIATED);
+			}
+			break;
+
+		case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		case Q921_STATE_TIMER_RECOVERY:
+			if(!Q921_IS_NT(trunk)) {
+				/* Discard I queue */
+				MFIFOClear(link->IFrameQueue);
+
+				/* establish data link */
+				Q921EstablishDataLink(trunk, link->tei);
+
+				/* Set layer 3 initiated */
+				Q921_SET_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+				/* change state (no action) */
+				Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, link->tei);
+			}
+			break;
+
+		default:
+			break;
+		}
+		break;
+
+	case Q921_DL_RELEASE:
+		switch(link->state) {
+		case Q921_STATE_TEI_ASSIGNED:
+			/* send DL-RELEASE confirm */
+			Q921Tx23Proc(trunk, Q921_DL_RELEASE, tei, NULL, 0);
+			break;
+
+		case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		case Q921_STATE_TIMER_RECOVERY:
+			if(!Q921_IS_NT(trunk)) {
+				/* Discard I queue */
+				MFIFOClear(link->IFrameQueue);
+
+				/* RC = 0 */
+				link->N200 = 0;
+
+				/* send DISC command */
+				Q921SendDISC(trunk, trunk->sapi, Q921_COMMAND(trunk), link->tei, 1);
+
+				/* Stop T203, restart T200 */
+				if(link->state == Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+					Q921T203TimerStop(trunk, link->tei);
+				}
+				Q921T200TimerReset(trunk, link->tei);
+
+				/* change state */
+				Q921ChangeState(trunk, Q921_STATE_AWAITING_RELEASE, link->tei);
+			}
+			break;
+
+		default:
+			break;
+		}
+		break;
+
+	case Q921_DL_DATA:	/* DL-DATA request */
+		res = Q921EnqueueI(trunk, 
+				trunk->sapi, 
+				Q921_COMMAND(trunk),
+				link->tei,
+				0, 
+				Mes, 
+				Size);
+
+		if(link->state < Q921_STATE_MULTIPLE_FRAME_ESTABLISHED) {
+			/* Treat as implicit DL-ESTABLISH request */
+
+			/* establish data link */
+			Q921EstablishDataLink(trunk, link->tei);
+
+			/* Set layer 3 initiated */
+			Q921_SET_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+			/* change state (no action) */
+			Q921ChangeState(trunk, Q921_STATE_AWAITING_ESTABLISHMENT, link->tei);
+		}
+		break;
+
+	case Q921_DL_UNIT_DATA:		/* DL-UNIT DATA request */
+		res = Q921SendUN(trunk,
+				trunk->sapi,
+				Q921_COMMAND(trunk),
+				Q921_TEI_BCAST,
+				0,
+				Mes,
+				Size);
+		/* NOTE: Let the other side initiate link establishment */
+		break;
+
+	default:
+		break;
+	}
+
+	return res;
 }
 /*****************************************************************************
 
@@ -267,16 +1625,11 @@ int Q921Rx32(L2TRUNK trunk, L2UCHAR * Mes, L2INT Size)
 
 *****************************************************************************/
 
-int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)0x01;
-    mes[trunk->Q921HeaderSpace+3] = (L2UCHAR)((trunk->vr<<1) | (pf & 0x01));
-
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+4);
+	return Q921SendS(trunk, Sapi, cr, Tei, pf, 0x00, mes, trunk->Q921HeaderSpace+4);
 }
 
 /*****************************************************************************
@@ -294,16 +1647,11 @@ int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
   Return Value: 0 if failed, 1 if Send.
 
 *****************************************************************************/
-int Q921SendRNR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendRNR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
-
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)0x05;
-    mes[trunk->Q921HeaderSpace+3] = (L2UCHAR)((trunk->vr<<1) | (pf & 0x01));
+	L2UCHAR mes[25];
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+4);
+	return Q921SendS(trunk, Sapi, cr, Tei, pf, 0x01, mes, trunk->Q921HeaderSpace+4);
 }
 
 /*****************************************************************************
@@ -321,16 +1669,11 @@ int Q921SendRNR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
   Return Value: 0 if failed, 1 if Send.
 
 *****************************************************************************/
-int Q921SendREJ(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendREJ(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
-
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)0x09;
-    mes[trunk->Q921HeaderSpace+3] = (L2UCHAR)((trunk->vr<<1) | (pf & 0x01));
+	L2UCHAR mes[25];
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+4);
+	return Q921SendS(trunk, Sapi, cr, Tei, pf, 0x03, mes, trunk->Q921HeaderSpace+4);
 }
 
 /*****************************************************************************
@@ -348,31 +1691,150 @@ int Q921SendREJ(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
   Return Value: 0 if failed, 1 if Send.
 
 *****************************************************************************/
-int Q921SendSABME(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendSABME(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x6f | ((pf<<4)&0x10));
-
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x0f, mes, trunk->Q921HeaderSpace+3);
 }
 
+
+/**
+ * Q921Start
+ * \brief	Start trunk
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ */
 int Q921Start(L2TRUNK trunk)
 {
-	return Q921SendSABME(trunk, 
+	int x, numlinks = Q921_IS_PTMP_NT(trunk) ? Q921_TEI_MAX : 1;
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+
+	if(trunk->initialized != INITIALIZED_MAGIC)
+		return 0;
+
+	memset(trunk->context, 0, numlinks * sizeof(struct Q921_Link));
+
+	/* Common init part */
+	for(x = 0; x <= numlinks; x++) {
+		link = Q921_LINK_CONTEXT(trunk, x);
+
+		link->state = Q921_STATE_TEI_UNASSIGNED;
+		link->tei   = 0;
+
+		/* Initialize per-TEI I + UI queues */
+		MFIFOCreate(link->UIFrameQueue, Q921MAXHDLCSPACE, 10);
+		MFIFOCreate(link->IFrameQueue,  Q921MAXHDLCSPACE, 10);
+		MFIFOCreate(link->IFrameResendQueue, Q921MAXHDLCSPACE, 10);
+	}
+
+	if(Q921_IS_PTMP_TE(trunk)) {
+		link->state = Q921_STATE_TEI_UNASSIGNED;
+		link->tei   = 0;
+	}
+	else if(Q921_IS_PTMP_NT(trunk)) {
+		link = Q921_TRUNK_CONTEXT(trunk);
+
+		link->state = Q921_STATE_TEI_ASSIGNED;
+		link->tei   = trunk->tei;
+
+		/* clear tei map */
+		memset(trunk->tei_map, 0, Q921_TEI_MAX + 1);
+	}
+	else {
+		link->state = Q921_STATE_TEI_ASSIGNED;
+		link->tei   = trunk->tei;
+	}
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Starting trunk %p (sapi: %d, tei: %d, mode: %s %s)\n",
+				 trunk,
+				 trunk->sapi,
+				 link->tei,
+				 Q921_IS_PTMP(trunk) ? "PTMP" : "PTP",
+				 Q921_IS_TE(trunk) ? "TE" : "NT");
+
+	if(Q921_IS_PTP(trunk)) {
+		Q921Log(trunk, Q921_LOG_DEBUG, "Sending SABME\n");
+
+		return Q921SendSABME(trunk, 
 					trunk->sapi, 
-					trunk->NetUser == Q921_TE ? 0 : 1,
-					trunk->tei, 
+					Q921_COMMAND(trunk),
+					link->tei, 
 					1);
+
+	} else if(Q921_IS_PTMP_NT(trunk)) {
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Revoking all TEIs\n");
+
+		return Q921TeiSendRemoveRequest(trunk, Q921_TEI_BCAST);	/* Revoke all TEIs in use */
+	} else {
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Requesting TEI\n");
+
+		return Q921TeiSendAssignRequest(trunk);
+	}
+}
+
+
+/**
+ * Q921Stop
+ * \brief	Stop trunk
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+int Q921Stop(L2TRUNK trunk)
+{
+	struct Q921_Link *link;
+	int x, numlinks;
+
+	if(!trunk)
+		return -1;
+
+	link = Q921_TRUNK_CONTEXT(trunk);
+	numlinks = Q921_IS_PTMP_NT(trunk) ? Q921_TEI_MAX : 1;
+
+	if(Q921_IS_STOPPED(link))
+		return 0;
+
+	/* Release TEI */
+	if(Q921_IS_PTMP_TE(trunk)) {
+		/* send verify request */
+		Q921TeiSendVerifyRequest(trunk);
+
+		/* drop TEI */
+		link->tei  = 0;
+	}
+
+	/* Stop timers, stop link, flush queues */
+	for(x = 0; x <= numlinks; x++) {
+		Q921T200TimerStop(trunk, x);
+		Q921T203TimerStop(trunk, x);
+		Q921T201TimerStop(trunk, x);
+
+		/* Change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_STOPPED, x);
+
+		/* Flush per-tei I/UI queues */
+		MFIFOClear(link->UIFrameQueue);
+		MFIFOClear(link->IFrameQueue);
+		MFIFOClear(link->IFrameResendQueue);
+	}
+	Q921T202TimerStop(trunk);
+
+	/* Flush HDLC queue */
+	MFIFOClear(trunk->HDLCInQueue);
+
+	return 0;
 }
 
+
 /*****************************************************************************
 
   Function:     Q921SendDM
 
-  Description:  Comose and Send DM (Disconnected Mode)
+  Description:  Compose and Send DM (Disconnected Mode)
 
   Parameters:   trunk       trunk #
                 Sapi        Sapi
@@ -383,15 +1845,11 @@ int Q921Start(L2TRUNK trunk)
   Return Value: 0 if failed, 1 if Send.
 
 *****************************************************************************/
-int Q921SendDM(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendDM(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
+	L2UCHAR mes[25];
 
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x0f | ((pf<<4)&0x10));
-
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x03, mes, trunk->Q921HeaderSpace+3);
 }
 
 /*****************************************************************************
@@ -409,15 +1867,11 @@ int Q921SendDM(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
   Return Value: 0 if failed, 1 if Send.
 
 *****************************************************************************/
-int Q921SendDISC(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
+static int Q921SendDISC(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf)
 {
-    L2UCHAR mes[400];
-
-    mes[trunk->Q921HeaderSpace+0] = (L2UCHAR)((Sapi&0xfc) | ((cr<<1)&0x02));
-    mes[trunk->Q921HeaderSpace+1] = (L2UCHAR)((Tei<<1) | 0x01);
-    mes[trunk->Q921HeaderSpace+2] = (L2UCHAR)(0x43 | ((pf<<4)&0x10));
+	L2UCHAR mes[25];
 
-    return Q921Tx21Proc(trunk, mes, trunk->Q921HeaderSpace+3);
+	return Q921SendU(trunk, Sapi, cr, Tei, pf, 0x08, mes, trunk->Q921HeaderSpace+3);
 }
 
 /*****************************************************************************
